# Class OjSwitch

The component WebElement for oj-switch. Do not instantiate this class directly, instead, use ojSwitch.

#### Hierarchy

- OjSwitchBase
  - OjSwitch

#####
Index

### Constructors

constructor

### Methods

changeMessagesCustom
changeValue
clear
click
findElement
findElements
getAttribute
getCssValue
getDescribedBy
getDisabled
getDisplayOptions
getDriver
getHelp
getHelpHints
getId
getLabelEdge
getLabelHint
getLabelledBy
getLocation
getMessagesCustom
getProperty
getReadonly
getReadonlyUserAssistanceShown
getRect
getShadowRoot
getSize
getTagName
getText
getTranslations
getUserAssistanceDensity
getValid
getValue
hasSize
hasVisibility
isDisplayed
isEnabled
isSelected
sendKeys
serialize
setProperty
submit
takeScreenshot
whenBusyContextReady
whenReady
buildId
equals
extractId
isId

## Constructors

### constructor

- new OjSwitch(el, locators): OjSwitch

- Constructor. Pass an instance of WebDriver's WebElement that represents the DOM node on which we"ll perform operations.

  #### Parameters

  - ##### el: WebElement

    The basic WebElement with which this WebElement will work.

  - ##### locators: ElementLocators

  #### Returns OjSwitch

  Inherited from OjSwitchBase.constructor

## Methods

### changeMessagesCustom

- changeMessagesCustom(messagesCustom): Promise<void>

- Sets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Parameters

  - ##### messagesCustom: object[]

    The value to set for `messagesCustom`

  #### Returns Promise<void>

  Inherited from OjSwitchBase.changeMessagesCustom

### changeValue

- changeValue(value): Promise<void>

- Sets the value of "value" property. The boolean state of the switch component.

  #### Parameters

  - ##### value: boolean

    The value to set for "value"

  #### Returns Promise<void>

  Overrides OjSwitchBase.changeValue

### clear

- clear(): Promise<void>

- Schedules a command to clear the `value` of this element. This command has no effect if the underlying DOM element is neither a text INPUT element nor a TEXTAREA element.

  #### Returns Promise<void>

  A promise that will be resolved when the element has been cleared.

  Inherited from OjSwitchBase.clear

### click

- click(): Promise<void>

- Schedules a command to click on this element.

  #### Returns Promise<void>

  A promise that will be resolved when the click command has completed.

  Inherited from OjSwitchBase.click

### findElement

- findElement(locator): WebElementPromise

- Schedule a command to find a descendant of this element. If the element cannot be found, a bot.ErrorCode.NO_SUCH_ELEMENT result will be returned by the driver. Unlike other commands, this error cannot be suppressed. In other words, scheduling a command to find an element doubles as an assert that the element is present on the page. To test whether an element is present on the page, use #findElements.

  The search criteria for an element may be defined using one of the factories in the By namespace, or as a short-hand By.Hash object. For example, the following two statements are equivalent:

      var e1 = element.findElement(By.id('foo'));
      var e2 = element.findElement({id:'foo'});

  You may also provide a custom locator function, which takes as input this WebDriver instance and returns a WebElement, or a promise that will resolve to a WebElement. For example, to find the first visible link on a page, you could write:

      var link = element.findElement(firstVisibleLink);

      function firstVisibleLink(element) {
        var links = element.findElements(By.tagName('a'));
        return promise.filter(links, function(link) {
          return links.isDisplayed();
        }).then(function(visibleLinks) {
          return visibleLinks[0];
        });
      }

  #### Parameters

  - ##### locator: Locator

    The locator strategy to use when searching for the element.

  #### Returns WebElementPromise

  A WebElement that can be used to issue commands against the located element. If the element is not found, the element will be invalidated and all scheduled commands aborted.

  Inherited from OjSwitchBase.findElement

### findElements

- findElements(locator): Promise<WebElement[]>

- Schedules a command to find all of the descendants of this element that match the given search criteria.

  #### Parameters

  - ##### locator: Locator

    The locator strategy to use when searching for the element.

  #### Returns Promise<WebElement[]>

  A promise that will resolve to an array of WebElements.

  Inherited from OjSwitchBase.findElements

### getAttribute

- getAttribute(attributeName): Promise<string>

- Schedules a command to query for the value of the given attribute of the element. Will return the current value, even if it has been modified after the page has been loaded. More exactly, this method will return the value of the given attribute, unless that attribute is not present, in which case the value of the property with the same name is returned. If neither value is set, null is returned (for example, the 'value' property of a textarea element). The 'style' attribute is converted as best can be to a text representation with a trailing semi-colon. The following are deemed to be 'boolean' attributes and will return either 'true' or null:

  async, autofocus, autoplay, checked, compact, complete, controls, declare, defaultchecked, defaultselected, defer, disabled, draggable, ended, formnovalidate, hidden, indeterminate, iscontenteditable, ismap, itemscope, loop, multiple, muted, nohref, noresize, noshade, novalidate, nowrap, open, paused, pubdate, readonly, required, reversed, scoped, seamless, seeking, selected, spellcheck, truespeed, willvalidate

  Finally, the following commonly mis-capitalized attribute/property names are evaluated as expected:

  - 'class'
  - 'readonly'

  #### Parameters

  - ##### attributeName: string

    The name of the attribute to query.

  #### Returns Promise<string>

  A promise that will be resolved with the attribute's value. The returned value will always be either a string or null.

  Inherited from OjSwitchBase.getAttribute

### getCssValue

- getCssValue(cssStyleProperty): Promise<string>

- Schedules a command to query for the computed style of the element represented by this instance. If the element inherits the named style from its parent, the parent will be queried for its value. Where possible, color values will be converted to their hex representation (e.g. #00ff00 instead of rgb(0, 255, 0)).

  Warning: the value returned will be as the browser interprets it, so it may be tricky to form a proper assertion.

  #### Parameters

  - ##### cssStyleProperty: string

    The name of the CSS style property to look up.

  #### Returns Promise<string>

  A promise that will be resolved with the requested CSS value.

  Inherited from OjSwitchBase.getCssValue

### getDescribedBy

- getDescribedBy(): Promise<string>

- Gets the value of `describedBy` property. The form component's oj-label automatically sets described-by to make it accessible. It is not meant to be set by application developer.

  #### Returns Promise<string>

  The value of `describedBy` property.

  Inherited from OjSwitchBase.getDescribedBy

### getDisabled

- getDisabled(): Promise<boolean>

- Gets the value of `disabled` property. Specifies whether the component is disabled. The default is false.

  #### Returns Promise<boolean>

  The value of `disabled` property.

  Inherited from OjSwitchBase.getDisabled

### getDisplayOptions

- getDisplayOptions(): Promise<DisplayOptions>

- Gets the value of `displayOptions` property. Display options for auxiliary content that determines whether or not it should be displayed.

  #### Returns Promise<DisplayOptions>

  The value of `displayOptions` property.

  Inherited from OjSwitchBase.getDisplayOptions

### getDriver

- getDriver(): WebDriver

- #### Returns WebDriver

  The parent driver for this instance.

  Inherited from OjSwitchBase.getDriver

### getHelp

- getHelp(): Promise<Help>

- Gets the value of `help` property. Form component help information.

  #### Returns Promise<Help>

  The value of `help` property.

  Inherited from OjSwitchBase.getHelp

### getHelpHints

- getHelpHints(): Promise<HelpHints>

- Gets the value of `helpHints` property. Represents hints for an oj-form-layout element to render help information on the label of the editable component.

  #### Returns Promise<HelpHints>

  The value of `helpHints` property.

  Inherited from OjSwitchBase.getHelpHints

### getId

- getId(): Promise<string>

- #### Returns Promise<string>

  A promise that resolves to the server-assigned opaque ID assigned to this element.

  Inherited from OjSwitchBase.getId

### getLabelEdge

- getLabelEdge(): Promise<string>

- Gets the value of `labelEdge` property. Defines how the label of a component is created. See the Help documentation for more information.

  #### Returns Promise<string>

  The value of `labelEdge` property.

  Inherited from OjSwitchBase.getLabelEdge

### getLabelHint

- getLabelHint(): Promise<string>

- Gets the value of `labelHint` property. Represents a hint for oj-form-layout element to render a label on the editable component.

  #### Returns Promise<string>

  The value of `labelHint` property.

  Inherited from OjSwitchBase.getLabelHint

### getLabelledBy

- getLabelledBy(): Promise<null | string>

- Gets the value of `labelledBy` property. The oj-label sets the labelledBy property programmatically on the form component.

  #### Returns Promise<null | string>

  The value of `labelledBy` property.

  Inherited from OjSwitchBase.getLabelledBy

### getLocation

- getLocation(): Promise<ILocation>

- DEPRECATED 3.0 Schedules a command to compute the location of this element in page space.

  #### Returns Promise<ILocation>

  A promise that will be resolved to the element's location as a {@code {x:number, y:number}} object.

  Inherited from OjSwitchBase.getLocation

### getMessagesCustom

- getMessagesCustom(): Promise<object[]>

- Gets the value of `messagesCustom` property. A list of messages added by an application to the component. See the Help documentation for more information.

  #### Returns Promise<object[]>

  The value of `messagesCustom` property.

  Inherited from OjSwitchBase.getMessagesCustom

### getProperty

- getProperty<T>(propertyName): Promise<T>

- Get a named property value from this component. This function will wait for the application's busy context to complete before attempting to get the property value.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The name of the property

  #### Returns Promise<T>

  A Promise that yields a value for the named property.

  Inherited from OjSwitchBase.getProperty

### getReadonly

- getReadonly(): Promise<boolean>

- Gets the value of `readonly` property. Specifies whether the component is read-only. A read-only element cannot be modified, but user interaction is allowed. See the Help documentation for more information.

  #### Returns Promise<boolean>

  The value of `readonly` property.

  Inherited from OjSwitchBase.getReadonly

### getReadonlyUserAssistanceShown

- getReadonlyUserAssistanceShown(): Promise<string>

- Gets the value of `readonlyUserAssistanceShown` property. Specifies which user assistance types should be shown when the component is readonly.

  #### Returns Promise<string>

  The value of `readonlyUserAssistanceShown` property.

  Inherited from OjSwitchBase.getReadonlyUserAssistanceShown

### getRect

- getRect(): Promise<IRectangle>

- Returns an object describing an element's location, in pixels relative to the document element, and the element's size in pixels.

  #### Returns Promise<IRectangle>

  Inherited from OjSwitchBase.getRect

### getShadowRoot

- getShadowRoot(): ShadowRootPromise

- Get the shadow root of the current web element.

  #### Returns ShadowRootPromise

  A promise that will be resolved with the elements shadow root or rejected with NoSuchShadowRootError

  Inherited from OjSwitchBase.getShadowRoot

### getSize

- getSize(): Promise<ISize>

- DEPRECATED 3.0 Schedules a command to compute the size of this element's bounding box, in pixels.

  #### Returns Promise<ISize>

  A promise that will be resolved with the element's size as a {@code {width:number, height:number}} object.

  Inherited from OjSwitchBase.getSize

### getTagName

- getTagName(): Promise<string>

- Schedules a command to query for the tag/node name of this element.

  #### Returns Promise<string>

  A promise that will be resolved with the element's tag name.

  Inherited from OjSwitchBase.getTagName

### getText

- getText(): Promise<string>

- Get the visible (i.e. not hidden by CSS) innerText of this element, including sub-elements, without any leading or trailing whitespace.

  #### Returns Promise<string>

  A promise that will be resolved with the element's visible text.

  Inherited from OjSwitchBase.getText

### getTranslations

- getTranslations(): Promise<null | Translations>

- Gets the value of `translations` property. A collection of translated resources from the translation bundle, or null if this component has no resources.

  #### Returns Promise<null | Translations>

  The value of `translations` property.

  Inherited from OjSwitchBase.getTranslations

### getUserAssistanceDensity

- getUserAssistanceDensity(): Promise<string>

- Gets the value of `userAssistanceDensity` property. Specifies the density of the form component's user assistance presentation.

  #### Returns Promise<string>

  The value of `userAssistanceDensity` property.

  Inherited from OjSwitchBase.getUserAssistanceDensity

### getValid

- getValid(): Promise<string>

- Gets the value of `valid` property. The validity state of the component

  #### Returns Promise<string>

  The value of `valid` property.

  Inherited from OjSwitchBase.getValid

### getValue

- getValue(): Promise<boolean>

- Gets the value of `value` property. The boolean state of the switch component.

  #### Returns Promise<boolean>

  The value of `value` property.

  Inherited from OjSwitchBase.getValue

### `Protected` hasSize

- hasSize(): Condition<Promise<boolean>>

- Create a wait condition that is satisfied when the element's DOM has a non-zero size.

  #### Returns Condition<Promise<boolean>>

  The Condition to be used with driver.wait() that's satisfied when the element's DOM has a non-zero size.

  #### Deprecated

  Since 11.0.0. Call the appropriate WebElement method to test the size of the element.

  Inherited from OjSwitchBase.hasSize

### `Protected` hasVisibility

- hasVisibility(): Condition<Promise<boolean>>

- Create a wait condition that is satisfid when the element is visible. The condition is satisfied when the element is displayed, as reported by #isDisplayed, and is scrolled into view. This is method is deprecated. Use WebElement.isDisplayed instead to test the display of the element, and scroll it into view if necessary.

  #### Returns Condition<Promise<boolean>>

  #### Deprecated

  Inherited from OjSwitchBase.hasVisibility

### isDisplayed

- isDisplayed(): Promise<boolean>

- Schedules a command to test whether this element is currently displayed.

  #### Returns Promise<boolean>

  A promise that will be resolved with whether this element is currently visible on the page.

  Inherited from OjSwitchBase.isDisplayed

### isEnabled

- isEnabled(): Promise<boolean>

- Schedules a command to query whether the DOM element represented by this instance is enabled, as dicted by the {@code disabled} attribute.

  #### Returns Promise<boolean>

  A promise that will be resolved with whether this element is currently enabled.

  Inherited from OjSwitchBase.isEnabled

### isSelected

- isSelected(): Promise<boolean>

- Schedules a command to query whether this element is selected.

  #### Returns Promise<boolean>

  A promise that will be resolved with whether this element is currently selected.

  Inherited from OjSwitchBase.isSelected

### sendKeys

- sendKeys(...varArgs): Promise<void>

- Schedules a command to type a sequence on the DOM element represented by this promsieinstance.

  Modifier keys (SHIFT, CONTROL, ALT, META) are stateful; once a modifier is processed in the keysequence, that key state is toggled until one of the following occurs:

  - The modifier key is encountered again in the sequence. At this point the state of the key is toggled (along with the appropriate keyup/down events).

  - The Key.NULL key is encountered in the sequence. When this key is encountered, all modifier keys current in the down state are released (with accompanying keyup events). The NULL key can be used to simulate common keyboard shortcuts:

          element.sendKeys('text was',
                           Key.CONTROL, 'a', Key.NULL,
                           'now text is');
          // Alternatively:
          element.sendKeys('text was',
                           Key.chord(Key.CONTROL, 'a'),
                           'now text is');

  - The end of the keysequence is encountered. When there are no more keys to type, all depressed modifier keys are released (with accompanying keyup events).

  If this element is a file input ({@code }), the specified key sequence should specify the path to the file to attach to the element. This is analgous to the user clicking 'Browse...' and entering the path into the file select dialog.

      var form = driver.findElement(By.css('form'));
      var element = form.findElement(By.css('input[type=file]'));
      element.sendKeys('/path/to/file.txt');
      form.submit();

  For uploads to function correctly, the entered path must reference a file on the browser's machine, not the local machine running this script. When running against a remote Selenium server, a FileDetector may be used to transparently copy files to the remote machine before attempting to upload them in the browser.

  Note: On browsers where native keyboard events are not supported (e.g. Firefox on OS X), key events will be synthesized. Special punctionation keys will be synthesized according to a standard QWERTY en-us keyboard layout.

  #### Parameters

  - ##### `Rest` ...varArgs: (string | number | Promise<string | number>)[]

    The sequence of keys to type. All arguments will be joined into a single sequence.

  #### Returns Promise<void>

  A promise that will be resolved when all keys have been typed.

  Inherited from OjSwitchBase.sendKeys

### serialize

- serialize(): Promise<IWebElementId>

- #### Returns Promise<IWebElementId>

  Inherited from OjSwitchBase.serialize

### `Protected` setProperty

- setProperty<T>(propertyName, value): Promise<void>

- Set a property value on the remote element. This function first waits for the BusyContext to clear before setting the property, then after setting, waits again to ensure that no additional busy states were created due to the property setting.

  #### Type Parameters

  - #### T = string

  #### Parameters

  - ##### propertyName: string

    The property name to set

  - ##### value: T

    The value to set for the property

  #### Returns Promise<void>

  A Promise which resolves when the remote property has been set to the value. Any value returned from the call to set the remote property is returned in the Promise.

  Inherited from OjSwitchBase.setProperty

### submit

- submit(): Promise<void>

- Schedules a command to submit the form containing this element (or this element if it is a FORM element). This command is a no-op if the element is not contained in a form.

  #### Returns Promise<void>

  A promise that will be resolved when the form has been submitted.

  Inherited from OjSwitchBase.submit

### takeScreenshot

- takeScreenshot(optScroll?): Promise<string>

- Take a screenshot of the visible region encompassed by this element's bounding rectangle.

  #### Parameters

  - ##### `Optional` optScroll: boolean

    Optional argument that indicates whether the element should be scrolled into view before taking a screenshot. Defaults to false.

  #### Returns Promise<string>

  A promise that will be resolved to the screenshot as a base-64 encoded PNG.

  Inherited from OjSwitchBase.takeScreenshot

### whenBusyContextReady

- whenBusyContextReady(): Promise<void>

- Returns a Promise that is resolved when the application's busy state reports ready. This method checks only that the application's busy context is ready, and not that the DOM element is actually displayed or has a physical size, such as is the case with #whenReady. Operations which are read-only in nature should call this method prior to execution.

  #### Returns Promise<void>

  A Promise which is resolved when the page's busy state is ready.

  Inherited from OjSwitchBase.whenBusyContextReady

### whenReady

- whenReady(): Promise<void>

- Returns a Promise that is resolved when the element is ready for interaction--it is visible, has a size, and the app's busy context is ready. Operations on the DOM which rely on its physical location and size to be in a "ready" state should use this command, such as clicking, sending keys, locating child elements, and so on.

  #### Returns Promise<void>

  A Promise that's resolved when all conditions are met.

  Inherited from OjSwitchBase.whenReady

### `Static` buildId

- buildId(id, opt_noLegacy?): IWebElementId

- #### Parameters

  - ##### id: string

    The raw ID.

  - ##### `Optional` opt_noLegacy: boolean

    Whether to exclude the legacy element key.

  #### Returns IWebElementId

  The element ID for use with WebDriver's wire protocol.

  Inherited from OjSwitchBase.buildId

### `Static` equals

- equals(a, b): Promise<boolean>

- Compares two WebElements for equality.

  #### Parameters

  - ##### a: WebElement

    A WebElement.

  - ##### b: WebElement

    A WebElement.

  #### Returns Promise<boolean>

  A promise that will be resolved to whether the two WebElements are equal.

  Inherited from OjSwitchBase.equals

### `Static` extractId

- extractId(obj): string

- Extracts the encoded WebElement ID from the object.

  #### Parameters

  - ##### obj: IWebElementId

    The object to extract the ID from.

  #### Returns string

  the extracted ID.

  #### Throws

  if the object is not a valid encoded ID.

  Inherited from OjSwitchBase.extractId

### `Static` isId

- isId(obj): boolean

- #### Parameters

  - ##### obj: IWebElementId

    the object to test.

  #### Returns boolean

  whether the object is a valid encoded WebElement ID.

  Inherited from OjSwitchBase.isId

Generated using TypeDoc